'''
SatProwler ver.1.3.3, HW 1.0, Created by Hugocz 17.3.2023
'''

import pigpio, configparser, time
from flask import Flask, render_template
from flask_socketio import SocketIO, emit
import datetime

posAZ = int(5000)               # aktuální hodnota azimutu
dirAZ = int(0)                  # aktuální směr pohybu azimutu
posEL = int(5000)               # aktuální hodnota elevace
dirEL = int(0)                  # aktuální směr pohybu elevace
Skew  = int(1500)               # aktuální skew, 1500 = střed 
Polar = 'H'                     # aktuální polarizace
SatPos = 'Not set'              # aktuální pozice ve stupních - text
SatName = 'Not set'             # aktuální družice
SrvMin = int(780)               # Počet imp. pro polohu serva -90°, HW minimum = 500
SrvMax = int(2220)              # Počet imp. pro polohu serva +90°, HW maximum 2500
SrvStep = int(5)                # krok serva na jedno kliknutí ve °

PortSr_1 = 5  # output, Servo1 (Skew)
PortSr_2 = 6  # output, Servo2
SetDirEl = 17 # směr pohybu elevace
StartEl  = 27 # spuštění pohybu elevace
SetDirAz = 4  # směr pohybu azimutu
StartAz  = 23 # spuštění pohybu azimutu
InputElA = 19 # impulzy Elevace A
InputElB = 26 # impulzy Elevace B
InputAzA = 20 # impulzy Azimut A
InputAzB = 21 # impulzy Azimut B
InputOEl = 16 # spínač origin Elevace
InputOAz = 12 # spínač origin Azimut

config = configparser.ConfigParser()
config.read('config.ini')
posAZ = config.getint('Default', 'posaz')
posEL = config.getint('Default', 'posel')
SatPos = config.get('Default', 'satpos')
Skew = config.getint('Default', 'skew')
Polar = config.get('Default', 'polar')
SatName = config.get('Default', 'satname')

async_mode = None

app = Flask(__name__)
socketio = SocketIO(app, async_mode=async_mode)

pi1 = pigpio.pi()                       # napojení na démona
pi1.set_mode(SetDirEl, pigpio.OUTPUT) 
pi1.set_mode(StartEl, pigpio.OUTPUT) 
pi1.set_mode(SetDirAz, pigpio.OUTPUT)  
pi1.set_mode(StartAz, pigpio.OUTPUT)
pi1.set_mode(PortSr_1, pigpio.OUTPUT)
pi1.set_servo_pulsewidth(PortSr_1, 0)    # Pulse off
pi1.set_mode(PortSr_2, pigpio.OUTPUT)
pi1.set_servo_pulsewidth(PortSr_2, 0)    # Pulse off
pi1.set_mode(InputElA, pigpio.INPUT)  
pi1.set_pull_up_down(InputElA, pigpio.PUD_UP) # aktivuje pullup interní odpor
pi1.set_mode(InputElB, pigpio.INPUT)  
pi1.set_pull_up_down(InputElB, pigpio.PUD_UP) # aktivuje pullup interní odpor
pi1.set_mode(InputAzA, pigpio.INPUT)  
pi1.set_pull_up_down(InputAzA, pigpio.PUD_UP) # aktivuje pullup interní odpor
pi1.set_mode(InputAzB, pigpio.INPUT)  
pi1.set_pull_up_down(InputAzB, pigpio.PUD_UP) # aktivuje pullup interní odpor
pi1.set_mode(InputOEl, pigpio.INPUT)  
pi1.set_pull_up_down(InputOEl, pigpio.PUD_UP) # aktivuje pullup interní odpor
pi1.set_mode(InputOAz, pigpio.INPUT)  
pi1.set_pull_up_down(InputOAz, pigpio.PUD_UP) # aktivuje pullup interní odpor

if Polar == 'H':
    pi1.set_servo_pulsewidth(PortSr_1, Skew - round(45*(SrvMax-SrvMin)/180))
elif Polar == 'V':
    pi1.set_servo_pulsewidth(PortSr_1, Skew + round(45*(SrvMax-SrvMin)/180))
time.sleep(2)                                 # Čekání na nastavení pozice serva
pi1.set_servo_pulsewidth(PortSr_1, 0)

def cbf19(gpio, level, tick):   # impulzy Elevace A
    global posEL
    global dirEL
    if (dirEL == 0):
        posEL+=int(1)
    else:
        posEL-=int(1)

def cbf20(gpio, level, tick):   # impulzy Azimut A
    global posAZ
    global dirAZ
    if (dirAZ == 0):
        posAZ+=int(1)
    else:
        posAZ-=int(1)

def cbf21(gpio, level, tick):   # impulzy Azimut B
    global posAZ
    global dirAZ
    if (dirAZ == 0):
        posAZ+=int(1)
    else:
        posAZ-=int(1)

def cbf26(gpio, level, tick):   # impulzy Elevace B
    global posEL
    global dirEL
    if (dirEL == 0):
        posEL+=int(1)
    else:
        posEL-=int(1)
        
cbELA = pi1.callback(InputElA, pigpio.RISING_EDGE, cbf19)    
cbELB = pi1.callback(InputElB, pigpio.RISING_EDGE, cbf26)
cbAZA = pi1.callback(InputAzA, pigpio.RISING_EDGE, cbf20)
cbAZB = pi1.callback(InputAzB, pigpio.RISING_EDGE, cbf21)

def StartMoveEast():
    global dirAZ
    pi1.write(SetDirAz,1)
    dirAZ = int(1)
    pi1.write(StartAz,1)
def StopMoveEast():
    pi1.write(StartAz,0)
    pi1.write(SetDirAz,0)
    time.sleep(0.5)          # Čekání na setrvačnost motoru    
def StartMoveWest():
    global dirAZ
    dirAZ = int(0)
    pi1.write(StartAz,1)
def StopMoveWest():
    pi1.write(StartAz,0)
    time.sleep(0.5)          # Čekání na setrvačnost motoru
def StartMoveUp():
    global dirEL
    dirEL = int(0)
    pi1.write(StartEl,1)
def StopMoveUp():
    pi1.write(StartEl,0)
    time.sleep(0.5)          # Čekání na setrvačnost motoru
def StartMoveDown():
    global dirEL
    dirEL = int(1)
    pi1.write(SetDirEl,1)
    pi1.write(StartEl,1)
def StopMoveDown():
    pi1.write(StartEl,0)
    pi1.write(SetDirEl,0)
    time.sleep(0.5)          # Čekání na setrvačnost motoru    
                                        
def MoveToNewPos(amem):
    global posAZ
    global posEL
    global SatPos
    global Skew
    global SrvMin
    global SrvMax
    global SatName
    newposAZ = config.getint(amem, 'posaz')
    newposEL = config.getint(amem, 'posel')
    newposSatPos = config.get(amem, 'satpos')
    newposSkew = config.getint(amem, 'skew')
    newposSatName = config.get(amem, 'satname')
    
    if Polar == 'H':
        pi1.set_servo_pulsewidth(PortSr_1, newposSkew - round(45*(SrvMax-SrvMin)/180))
    elif Polar == 'V':
        pi1.set_servo_pulsewidth(PortSr_1, newposSkew + round(45*(SrvMax-SrvMin)/180))
    
    # Case 1 from 8
    if ((newposAZ < posAZ) and (newposEL == posEL)) :
        StartMoveEast()
        count = 0
        while (newposAZ < (posAZ - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveEast()
    # Case 2 from 8 
    elif ((newposAZ > posAZ) and (newposEL == posEL)) :
        StartMoveWest()
        count = 0
        while (newposAZ > (posAZ + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveWest()
    # Case 3 from 8 
    elif ((newposEL < posEL) and (newposAZ == posAZ)) :
        StartMoveDown()
        count = 0
        while (newposEL < (posEL - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveDown()
    # Case 4 from 8 
    elif ((newposEL > posEL) and (newposAZ == posAZ)) :
        StartMoveUp()
        count = 0
        while (newposEL > (posEL + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveUp()
    # Case 5 from 8 
    elif ((newposAZ < posAZ) and (newposEL < posEL)) :
        StartMoveEast()
        count = 0
        while (newposAZ < (posAZ - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveEast()
        StartMoveDown()
        count = 0
        while (newposEL < (posEL - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveDown()
    # Case 6 from 8 
    elif ((newposAZ > posAZ) and (newposEL < posEL)) :
        StartMoveWest()
        count = 0
        while (newposAZ > (posAZ + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveWest()
        StartMoveDown()
        count = 0
        while (newposEL < (posEL - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveDown()
    # Case 7 from 8 
    elif ((newposAZ < posAZ) and (newposEL > posEL)) :
        StartMoveEast()
        count = 0
        while (newposAZ < (posAZ - 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveEast()
        StartMoveUp()
        count = 0
        while (newposEL > (posEL + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveUp()
    # Case 8 from 8 
    elif ((newposAZ > posAZ) and (newposEL > posEL)) :
        StartMoveWest()
        count = 0
        while (newposAZ > (posAZ + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"AZ: {posAZ} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveWest()
        StartMoveUp()
        count = 0
        while (newposEL > (posEL + 20)):
            time.sleep(0.05)          # Čekání na novou pozici
            count += 1
            if count > 10 :
                count = 0
                print(f"EL: {posEL} impulzů. {datetime.datetime.now()}")
                socketio.emit('set_data_3sel', 
                    {'dataAZ': posAZ, 
                     'dataEL': posEL, 
                     'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
        StopMoveUp()
                            
    pi1.set_servo_pulsewidth(PortSr_1, 0)
    SatPos = newposSatPos
    SatName  = newposSatName
    Skew     = newposSkew
    socketio.emit('set_data_all', 
        {'dataAZ': posAZ, 
         'dataEL': posEL, 
         'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1), 
         'dataSatPos': SatPos, 
         'dataSatName': SatName})
        
@app.route("/")
def index():
    if (config.get('Default', 'polar') == 'H'):
        btnHclassname = 'btnmempresetson'
        btnVclassname = 'btnmempresetsoff'
    elif (config.get('Default', 'polar') == 'V'):
        btnVclassname = 'btnmempresetson'
        btnHclassname = 'btnmempresetsoff'
    if ((config.getint('mem01', 'posaz') == 0) and (config.getint('mem01', 'posel') == 0)) :
        mem01classname = 'btnmempresetsoff'
    else:
        mem01classname = 'btnmempresetson'
    mem01position = config.get('mem01', 'satpos')
    mem01title = config.get('mem01', 'satname')    
    if ((config.getint('mem02', 'posaz') == 0) and (config.getint('mem02', 'posel') == 0)) :
        mem02classname = 'btnmempresetsoff'
    else:
        mem02classname = 'btnmempresetson'
    mem02position = config.get('mem02', 'satpos')
    mem02title = config.get('mem02', 'satname')
    if ((config.getint('mem03', 'posaz') == 0) and (config.getint('mem03', 'posel') == 0)) :
        mem03classname = 'btnmempresetsoff'
    else:
        mem03classname = 'btnmempresetson'
    mem03position = config.get('mem03', 'satpos')
    mem03title = config.get('mem03', 'satname') 
    if ((config.getint('mem04', 'posaz') == 0) and (config.getint('mem04', 'posel') == 0)) :
        mem04classname = 'btnmempresetsoff'
    else:
        mem04classname = 'btnmempresetson'
    mem04position = config.get('mem04', 'satpos')
    mem04title = config.get('mem04', 'satname') 
    if ((config.getint('mem05', 'posaz') == 0) and (config.getint('mem05', 'posel') == 0)) :
        mem05classname = 'btnmempresetsoff'
    else:
        mem05classname = 'btnmempresetson'
    mem05position = config.get('mem05', 'satpos')
    mem05title = config.get('mem05', 'satname') 
    if ((config.getint('mem06', 'posaz') == 0) and (config.getint('mem06', 'posel') == 0)) :
        mem06classname = 'btnmempresetsoff'
    else:
        mem06classname = 'btnmempresetson'
    mem06position = config.get('mem06', 'satpos')
    mem06title = config.get('mem06', 'satname')
    if ((config.getint('mem07', 'posaz') == 0) and (config.getint('mem07', 'posel') == 0)) :
        mem07classname = 'btnmempresetsoff'
    else:
        mem07classname = 'btnmempresetson'
    mem07position = config.get('mem07', 'satpos')
    mem07title = config.get('mem07', 'satname')                         
    if ((config.getint('mem08', 'posaz') == 0) and (config.getint('mem08', 'posel') == 0)) :
        mem08classname = 'btnmempresetsoff'
    else:
        mem08classname = 'btnmempresetson'
    mem08position = config.get('mem08', 'satpos')
    mem08title = config.get('mem08', 'satname')
    if ((config.getint('mem09', 'posaz') == 0) and (config.getint('mem09', 'posel') == 0)) :
        mem09classname = 'btnmempresetsoff'
    else:
        mem09classname = 'btnmempresetson'
    mem09position = config.get('mem09', 'satpos')
    mem09title = config.get('mem09', 'satname')
    if ((config.getint('mem10', 'posaz') == 0) and (config.getint('mem10', 'posel') == 0)) :
        mem10classname = 'btnmempresetsoff'
    else:
        mem10classname = 'btnmempresetson'
    mem10position = config.get('mem10', 'satpos')
    mem10title = config.get('mem10', 'satname')
    if ((config.getint('mem11', 'posaz') == 0) and (config.getint('mem11', 'posel') == 0)) :
        mem11classname = 'btnmempresetsoff'
    else:
        mem11classname = 'btnmempresetson'
    mem11position = config.get('mem11', 'satpos')
    mem11title = config.get('mem11', 'satname')
    if ((config.getint('mem12', 'posaz') == 0) and (config.getint('mem12', 'posel') == 0)) :
        mem12classname = 'btnmempresetsoff'
    else:
        mem12classname = 'btnmempresetson'
    mem12position = config.get('mem12', 'satpos')
    mem12title = config.get('mem12', 'satname')
    if ((config.getint('mem13', 'posaz') == 0) and (config.getint('mem13', 'posel') == 0)) :
        mem13classname = 'btnmempresetsoff'
    else:
        mem13classname = 'btnmempresetson'
    mem13position = config.get('mem13', 'satpos')
    mem13title = config.get('mem13', 'satname')
    if ((config.getint('mem14', 'posaz') == 0) and (config.getint('mem14', 'posel') == 0)) :
        mem14classname = 'btnmempresetsoff'
    else:
        mem14classname = 'btnmempresetson'
    mem14position = config.get('mem14', 'satpos')
    mem14title = config.get('mem14', 'satname')
    if ((config.getint('mem15', 'posaz') == 0) and (config.getint('mem15', 'posel') == 0)) :
        mem15classname = 'btnmempresetsoff'
    else:
        mem15classname = 'btnmempresetson'
    mem15position = config.get('mem15', 'satpos')
    mem15title = config.get('mem15', 'satname')
    if ((config.getint('mem16', 'posaz') == 0) and (config.getint('mem16', 'posel') == 0)) :
        mem16classname = 'btnmempresetsoff'
    else:
        mem16classname = 'btnmempresetson'
    mem16position = config.get('mem16', 'satpos')
    mem16title = config.get('mem16', 'satname')
    if ((config.getint('mem17', 'posaz') == 0) and (config.getint('mem17', 'posel') == 0)) :
        mem17classname = 'btnmempresetsoff'
    else:
        mem17classname = 'btnmempresetson'
    mem17position = config.get('mem17', 'satpos')
    mem17title = config.get('mem17', 'satname')
    if ((config.getint('mem18', 'posaz') == 0) and (config.getint('mem18', 'posel') == 0)) :
        mem18classname = 'btnmempresetsoff'
    else:
        mem18classname = 'btnmempresetson'
    mem18position = config.get('mem18', 'satpos')
    mem18title = config.get('mem18', 'satname')
    if ((config.getint('mem19', 'posaz') == 0) and (config.getint('mem19', 'posel') == 0)) :
        mem19classname = 'btnmempresetsoff'
    else:
        mem19classname = 'btnmempresetson'
    mem19position = config.get('mem19', 'satpos')
    mem19title = config.get('mem19', 'satname')
    if ((config.getint('mem20', 'posaz') == 0) and (config.getint('mem20', 'posel') == 0)) :
        mem20classname = 'btnmempresetsoff'
    else:
        mem20classname = 'btnmempresetson'
    mem20position = config.get('mem20', 'satpos')
    mem20title = config.get('mem20', 'satname')
    if ((config.getint('mem21', 'posaz') == 0) and (config.getint('mem21', 'posel') == 0)) :
        mem21classname = 'btnmempresetsoff'
    else:
        mem21classname = 'btnmempresetson'
    mem21position = config.get('mem21', 'satpos')
    mem21title = config.get('mem21', 'satname')
    if ((config.getint('mem22', 'posaz') == 0) and (config.getint('mem22', 'posel') == 0)) :
        mem22classname = 'btnmempresetsoff'
    else:
        mem22classname = 'btnmempresetson'
    mem22position = config.get('mem22', 'satpos')
    mem22title = config.get('mem22', 'satname')
    if ((config.getint('mem23', 'posaz') == 0) and (config.getint('mem23', 'posel') == 0)) :
        mem23classname = 'btnmempresetsoff'
    else:
        mem23classname = 'btnmempresetson'
    mem23position = config.get('mem23', 'satpos')
    mem23title = config.get('mem23', 'satname')
    if ((config.getint('mem24', 'posaz') == 0) and (config.getint('mem24', 'posel') == 0)) :
        mem24classname = 'btnmempresetsoff'
    else:
        mem24classname = 'btnmempresetson'
    mem24position = config.get('mem24', 'satpos')
    mem24title = config.get('mem24', 'satname')
    if ((config.getint('mem25', 'posaz') == 0) and (config.getint('mem25', 'posel') == 0)) :
        mem25classname = 'btnmempresetsoff'
    else:
        mem25classname = 'btnmempresetson'
    mem25position = config.get('mem25', 'satpos')
    mem25title = config.get('mem25', 'satname')
    if ((config.getint('mem26', 'posaz') == 0) and (config.getint('mem26', 'posel') == 0)) :
        mem26classname = 'btnmempresetsoff'
    else:
        mem26classname = 'btnmempresetson'
    mem26position = config.get('mem26', 'satpos')
    mem26title = config.get('mem26', 'satname')
    if ((config.getint('mem27', 'posaz') == 0) and (config.getint('mem27', 'posel') == 0)) :
        mem27classname = 'btnmempresetsoff'
    else:
        mem27classname = 'btnmempresetson'
    mem27position = config.get('mem27', 'satpos')
    mem27title = config.get('mem27', 'satname')
    if ((config.getint('mem28', 'posaz') == 0) and (config.getint('mem28', 'posel') == 0)) :
        mem28classname = 'btnmempresetsoff'
    else:
        mem28classname = 'btnmempresetson'
    mem28position = config.get('mem28', 'satpos')
    mem28title = config.get('mem28', 'satname')
    if ((config.getint('mem29', 'posaz') == 0) and (config.getint('mem29', 'posel') == 0)) :
        mem29classname = 'btnmempresetsoff'
    else:
        mem29classname = 'btnmempresetson'
    mem29position = config.get('mem29', 'satpos')
    mem29title = config.get('mem29', 'satname')
    if ((config.getint('mem30', 'posaz') == 0) and (config.getint('mem30', 'posel') == 0)) :
        mem30classname = 'btnmempresetsoff'
    else:
        mem30classname = 'btnmempresetson'
    mem30position = config.get('mem30', 'satpos')
    mem30title = config.get('mem30', 'satname')
    if ((config.getint('mem31', 'posaz') == 0) and (config.getint('mem31', 'posel') == 0)) :
        mem31classname = 'btnmempresetsoff'
    else:
        mem31classname = 'btnmempresetson'
    mem31position = config.get('mem31', 'satpos')
    mem31title = config.get('mem31', 'satname')
    if ((config.getint('mem32', 'posaz') == 0) and (config.getint('mem32', 'posel') == 0)) :
        mem32classname = 'btnmempresetsoff'
    else:
        mem32classname = 'btnmempresetson'
    mem32position = config.get('mem32', 'satpos')
    mem32title = config.get('mem32', 'satname')
    if ((config.getint('mem33', 'posaz') == 0) and (config.getint('mem33', 'posel') == 0)) :
        mem33classname = 'btnmempresetsoff'
    else:
        mem33classname = 'btnmempresetson'
    mem33position = config.get('mem33', 'satpos')
    mem33title = config.get('mem33', 'satname')
    if ((config.getint('mem34', 'posaz') == 0) and (config.getint('mem34', 'posel') == 0)) :
        mem34classname = 'btnmempresetsoff'
    else:
        mem34classname = 'btnmempresetson'
    mem34position = config.get('mem34', 'satpos')
    mem34title = config.get('mem34', 'satname')
    if ((config.getint('mem35', 'posaz') == 0) and (config.getint('mem35', 'posel') == 0)) :
        mem35classname = 'btnmempresetsoff'
    else:
        mem35classname = 'btnmempresetson'
    mem35position = config.get('mem35', 'satpos')
    mem35title = config.get('mem35', 'satname')
    if ((config.getint('mem36', 'posaz') == 0) and (config.getint('mem36', 'posel') == 0)) :
        mem36classname = 'btnmempresetsoff'
    else:
        mem36classname = 'btnmempresetson'
    mem36position = config.get('mem36', 'satpos')
    mem36title = config.get('mem36', 'satname')
    if ((config.getint('mem37', 'posaz') == 0) and (config.getint('mem37', 'posel') == 0)) :
        mem37classname = 'btnmempresetsoff'
    else:
        mem37classname = 'btnmempresetson'
    mem37position = config.get('mem37', 'satpos')
    mem37title = config.get('mem37', 'satname')
    if ((config.getint('mem38', 'posaz') == 0) and (config.getint('mem38', 'posel') == 0)) :
        mem38classname = 'btnmempresetsoff'
    else:
        mem38classname = 'btnmempresetson'
    mem38position = config.get('mem38', 'satpos')
    mem38title = config.get('mem38', 'satname')
    if ((config.getint('mem39', 'posaz') == 0) and (config.getint('mem39', 'posel') == 0)) :
        mem39classname = 'btnmempresetsoff'
    else:
        mem39classname = 'btnmempresetson'
    mem39position = config.get('mem39', 'satpos')
    mem39title = config.get('mem39', 'satname')
    if ((config.getint('mem40', 'posaz') == 0) and (config.getint('mem40', 'posel') == 0)) :
        mem40classname = 'btnmempresetsoff'
    else:
        mem40classname = 'btnmempresetson'
    mem40position = config.get('mem40', 'satpos')
    mem40title = config.get('mem40', 'satname')
    if ((config.getint('mem41', 'posaz') == 0) and (config.getint('mem41', 'posel') == 0)) :
        mem41classname = 'btnmempresetsoff'
    else:
        mem41classname = 'btnmempresetson'
    mem41position = config.get('mem41', 'satpos')
    mem41title = config.get('mem41', 'satname')
    if ((config.getint('mem42', 'posaz') == 0) and (config.getint('mem42', 'posel') == 0)) :
        mem42classname = 'btnmempresetsoff'
    else:
        mem42classname = 'btnmempresetson'
    mem42position = config.get('mem42', 'satpos')
    mem42title = config.get('mem42', 'satname')
    if ((config.getint('mem43', 'posaz') == 0) and (config.getint('mem43', 'posel') == 0)) :
        mem43classname = 'btnmempresetsoff'
    else:
        mem43classname = 'btnmempresetson'
    mem43position = config.get('mem43', 'satpos')
    mem43title = config.get('mem43', 'satname')
    if ((config.getint('mem44', 'posaz') == 0) and (config.getint('mem44', 'posel') == 0)) :
        mem44classname = 'btnmempresetsoff'
    else:
        mem44classname = 'btnmempresetson'
    mem44position = config.get('mem44', 'satpos')
    mem44title = config.get('mem44', 'satname')
    if ((config.getint('mem45', 'posaz') == 0) and (config.getint('mem45', 'posel') == 0)) :
        mem45classname = 'btnmempresetsoff'
    else:
        mem45classname = 'btnmempresetson'
    mem45position = config.get('mem45', 'satpos')
    mem45title = config.get('mem45', 'satname')
    if ((config.getint('mem46', 'posaz') == 0) and (config.getint('mem46', 'posel') == 0)) :
        mem46classname = 'btnmempresetsoff'
    else:
        mem46classname = 'btnmempresetson'
    mem46position = config.get('mem46', 'satpos')
    mem46title = config.get('mem46', 'satname')
    if ((config.getint('mem47', 'posaz') == 0) and (config.getint('mem47', 'posel') == 0)) :
        mem47classname = 'btnmempresetsoff'
    else:
        mem47classname = 'btnmempresetson'
    mem47position = config.get('mem47', 'satpos')
    mem47title = config.get('mem47', 'satname')
    if ((config.getint('mem48', 'posaz') == 0) and (config.getint('mem48', 'posel') == 0)) :
        mem48classname = 'btnmempresetsoff'
    else:
        mem48classname = 'btnmempresetson'
    mem48position = config.get('mem48', 'satpos')
    mem48title = config.get('mem48', 'satname')
    if ((config.getint('mem49', 'posaz') == 0) and (config.getint('mem49', 'posel') == 0)) :
        mem49classname = 'btnmempresetsoff'
    else:
        mem49classname = 'btnmempresetson'
    mem49position = config.get('mem49', 'satpos')
    mem49title = config.get('mem49', 'satname')
    if ((config.getint('mem50', 'posaz') == 0) and (config.getint('mem50', 'posel') == 0)) :
        mem50classname = 'btnmempresetsoff'
    else:
        mem50classname = 'btnmempresetson'
    mem50position = config.get('mem50', 'satpos')
    mem50title = config.get('mem50', 'satname')
    if ((config.getint('mem51', 'posaz') == 0) and (config.getint('mem51', 'posel') == 0)) :
        mem51classname = 'btnmempresetsoff'
    else:
        mem51classname = 'btnmempresetson'
    mem51position = config.get('mem51', 'satpos')
    mem51title = config.get('mem51', 'satname')
    if ((config.getint('mem52', 'posaz') == 0) and (config.getint('mem52', 'posel') == 0)) :
        mem52classname = 'btnmempresetsoff'
    else:
        mem52classname = 'btnmempresetson'
    mem52position = config.get('mem52', 'satpos')
    mem52title = config.get('mem52', 'satname')
    if ((config.getint('mem53', 'posaz') == 0) and (config.getint('mem53', 'posel') == 0)) :
        mem53classname = 'btnmempresetsoff'
    else:
        mem53classname = 'btnmempresetson'
    mem53position = config.get('mem53', 'satpos')
    mem53title = config.get('mem53', 'satname')
    if ((config.getint('mem54', 'posaz') == 0) and (config.getint('mem54', 'posel') == 0)) :
        mem54classname = 'btnmempresetsoff'
    else:
        mem54classname = 'btnmempresetson'
    mem54position = config.get('mem54', 'satpos')
    mem54title = config.get('mem54', 'satname')
    if ((config.getint('mem55', 'posaz') == 0) and (config.getint('mem55', 'posel') == 0)) :
        mem55classname = 'btnmempresetsoff'
    else:
        mem55classname = 'btnmempresetson'
    mem55position = config.get('mem55', 'satpos')
    mem55title = config.get('mem55', 'satname')
    if ((config.getint('mem56', 'posaz') == 0) and (config.getint('mem56', 'posel') == 0)) :
        mem56classname = 'btnmempresetsoff'
    else:
        mem56classname = 'btnmempresetson'
    mem56position = config.get('mem56', 'satpos')
    mem56title = config.get('mem56', 'satname')
    if ((config.getint('mem57', 'posaz') == 0) and (config.getint('mem57', 'posel') == 0)) :
        mem57classname = 'btnmempresetsoff'
    else:
        mem57classname = 'btnmempresetson'
    mem57position = config.get('mem57', 'satpos')
    mem57title = config.get('mem57', 'satname')
    if ((config.getint('mem58', 'posaz') == 0) and (config.getint('mem58', 'posel') == 0)) :
        mem58classname = 'btnmempresetsoff'
    else:
        mem58classname = 'btnmempresetson'
    mem58position = config.get('mem58', 'satpos')
    mem58title = config.get('mem58', 'satname')
    if ((config.getint('mem59', 'posaz') == 0) and (config.getint('mem59', 'posel') == 0)) :
        mem59classname = 'btnmempresetsoff'
    else:
        mem59classname = 'btnmempresetson'
    mem59position = config.get('mem59', 'satpos')
    mem59title = config.get('mem59', 'satname')
    if ((config.getint('mem60', 'posaz') == 0) and (config.getint('mem60', 'posel') == 0)) :
        mem60classname = 'btnmempresetsoff'
    else:
        mem60classname = 'btnmempresetson'
    mem60position = config.get('mem60', 'satpos')
    mem60title = config.get('mem60', 'satname')
    if ((config.getint('mem61', 'posaz') == 0) and (config.getint('mem61', 'posel') == 0)) :
        mem61classname = 'btnmempresetsoff'
    else:
        mem61classname = 'btnmempresetson'
    mem61position = config.get('mem61', 'satpos')
    mem61title = config.get('mem61', 'satname')
    if ((config.getint('mem62', 'posaz') == 0) and (config.getint('mem62', 'posel') == 0)) :
        mem62classname = 'btnmempresetsoff'
    else:
        mem62classname = 'btnmempresetson'
    mem62position = config.get('mem62', 'satpos')
    mem62title = config.get('mem62', 'satname')
    if ((config.getint('mem63', 'posaz') == 0) and (config.getint('mem63', 'posel') == 0)) :
        mem63classname = 'btnmempresetsoff'
    else:
        mem63classname = 'btnmempresetson'
    mem63position = config.get('mem63', 'satpos')
    mem63title = config.get('mem63', 'satname')
    if ((config.getint('mem64', 'posaz') == 0) and (config.getint('mem64', 'posel') == 0)) :
        mem64classname = 'btnmempresetsoff'
    else:
        mem64classname = 'btnmempresetson'
    mem64position = config.get('mem64', 'satpos')
    mem64title = config.get('mem64', 'satname')
    if ((config.getint('mem65', 'posaz') == 0) and (config.getint('mem65', 'posel') == 0)) :
        mem65classname = 'btnmempresetsoff'
    else:
        mem65classname = 'btnmempresetson'
    mem65position = config.get('mem65', 'satpos')
    mem65title = config.get('mem65', 'satname')
    if ((config.getint('mem66', 'posaz') == 0) and (config.getint('mem66', 'posel') == 0)) :
        mem66classname = 'btnmempresetsoff'
    else:
        mem66classname = 'btnmempresetson'
    mem66position = config.get('mem66', 'satpos')
    mem66title = config.get('mem66', 'satname')
    if ((config.getint('mem67', 'posaz') == 0) and (config.getint('mem67', 'posel') == 0)) :
        mem67classname = 'btnmempresetsoff'
    else:
        mem67classname = 'btnmempresetson'
    mem67position = config.get('mem67', 'satpos')
    mem67title = config.get('mem67', 'satname')
    if ((config.getint('mem68', 'posaz') == 0) and (config.getint('mem68', 'posel') == 0)) :
        mem68classname = 'btnmempresetsoff'
    else:
        mem68classname = 'btnmempresetson'
    mem68position = config.get('mem68', 'satpos')
    mem68title = config.get('mem68', 'satname')
    if ((config.getint('mem69', 'posaz') == 0) and (config.getint('mem69', 'posel') == 0)) :
        mem69classname = 'btnmempresetsoff'
    else:
        mem69classname = 'btnmempresetson'
    mem69position = config.get('mem69', 'satpos')
    mem69title = config.get('mem69', 'satname')
    if ((config.getint('mem70', 'posaz') == 0) and (config.getint('mem70', 'posel') == 0)) :
        mem70classname = 'btnmempresetsoff'
    else:
        mem70classname = 'btnmempresetson'
    mem70position = config.get('mem70', 'satpos')
    mem70title = config.get('mem70', 'satname')
    if ((config.getint('mem71', 'posaz') == 0) and (config.getint('mem71', 'posel') == 0)) :
        mem71classname = 'btnmempresetsoff'
    else:
        mem71classname = 'btnmempresetson'
    mem71position = config.get('mem71', 'satpos')
    mem71title = config.get('mem71', 'satname')
    if ((config.getint('mem72', 'posaz') == 0) and (config.getint('mem72', 'posel') == 0)) :
        mem72classname = 'btnmempresetsoff'
    else:
        mem72classname = 'btnmempresetson'
    mem72position = config.get('mem72', 'satpos')
    mem72title = config.get('mem72', 'satname')
    if ((config.getint('mem73', 'posaz') == 0) and (config.getint('mem73', 'posel') == 0)) :
        mem73classname = 'btnmempresetsoff'
    else:
        mem73classname = 'btnmempresetson'
    mem73position = config.get('mem73', 'satpos')
    mem73title = config.get('mem73', 'satname')
    if ((config.getint('mem74', 'posaz') == 0) and (config.getint('mem74', 'posel') == 0)) :
        mem74classname = 'btnmempresetsoff'
    else:
        mem74classname = 'btnmempresetson'
    mem74position = config.get('mem74', 'satpos')
    mem74title = config.get('mem74', 'satname')
    if ((config.getint('mem75', 'posaz') == 0) and (config.getint('mem75', 'posel') == 0)) :
        mem75classname = 'btnmempresetsoff'
    else:
        mem75classname = 'btnmempresetson'
    mem75position = config.get('mem75', 'satpos')
    mem75title = config.get('mem75', 'satname')
    if ((config.getint('mem76', 'posaz') == 0) and (config.getint('mem76', 'posel') == 0)) :
        mem76classname = 'btnmempresetsoff'
    else:
        mem76classname = 'btnmempresetson'
    mem76position = config.get('mem76', 'satpos')
    mem76title = config.get('mem76', 'satname')
    if ((config.getint('mem77', 'posaz') == 0) and (config.getint('mem77', 'posel') == 0)) :
        mem77classname = 'btnmempresetsoff'
    else:
        mem77classname = 'btnmempresetson'
    mem77position = config.get('mem77', 'satpos')
    mem77title = config.get('mem77', 'satname')
    if ((config.getint('mem78', 'posaz') == 0) and (config.getint('mem78', 'posel') == 0)) :
        mem78classname = 'btnmempresetsoff'
    else:
        mem78classname = 'btnmempresetson'
    mem78position = config.get('mem78', 'satpos')
    mem78title = config.get('mem78', 'satname')
    if ((config.getint('mem79', 'posaz') == 0) and (config.getint('mem79', 'posel') == 0)) :
        mem79classname = 'btnmempresetsoff'
    else:
        mem79classname = 'btnmempresetson'
    mem79position = config.get('mem79', 'satpos')
    mem79title = config.get('mem79', 'satname')
    if ((config.getint('mem80', 'posaz') == 0) and (config.getint('mem80', 'posel') == 0)) :
        mem80classname = 'btnmempresetsoff'
    else:
        mem80classname = 'btnmempresetson'
    mem80position = config.get('mem80', 'satpos')
    mem80title = config.get('mem80', 'satname')
    
    templateData = {
        'valueAZ'        : posAZ, 
        'valueEL'        : posEL,
        'valuePosition'  : SatPos,
        'valueSkew'      : round((180*Skew-270000)/(SrvMax-SrvMin),1),     
        'valueName'      : SatName,
        'btnHclassname'  : btnHclassname,
        'btnVclassname'  : btnVclassname,
        'mem01classname' : mem01classname,
        'mem01position'  : mem01position,
        'mem01title'     : mem01title,
        'mem02classname' : mem02classname,
        'mem02position'  : mem02position,
        'mem02title'     : mem02title,
        'mem03classname' : mem03classname,
        'mem03position'  : mem03position,
        'mem03title'     : mem03title,
        'mem04classname' : mem04classname,
        'mem04position'  : mem04position,
        'mem04title'     : mem04title,
        'mem05classname' : mem05classname,
        'mem05position'  : mem05position,
        'mem05title'     : mem05title,
        'mem06classname' : mem06classname,
        'mem06position'  : mem06position,
        'mem06title'     : mem06title,
        'mem07classname' : mem07classname,
        'mem07position'  : mem07position,
        'mem07title'     : mem07title,
        'mem08classname' : mem08classname,
        'mem08position'  : mem08position,
        'mem08title'     : mem08title,
        'mem09classname' : mem09classname,
        'mem09position'  : mem09position,
        'mem09title'     : mem09title,
        'mem10classname' : mem10classname,
        'mem10position'  : mem10position,
        'mem10title'     : mem10title,
        'mem11classname' : mem11classname,
        'mem11position'  : mem11position,
        'mem11title'     : mem11title,
        'mem12classname' : mem12classname,
        'mem12position'  : mem12position,
        'mem12title'     : mem12title,
        'mem13classname' : mem13classname,
        'mem13position'  : mem13position,
        'mem13title'     : mem13title,
        'mem14classname' : mem14classname,
        'mem14position'  : mem14position,
        'mem14title'     : mem14title,
        'mem15classname' : mem15classname,
        'mem15position'  : mem15position,
        'mem15title'     : mem15title,
        'mem16classname' : mem16classname,
        'mem16position'  : mem16position,
        'mem16title'     : mem16title,
        'mem17classname' : mem17classname,
        'mem17position'  : mem17position,
        'mem17title'     : mem17title,
        'mem18classname' : mem18classname,
        'mem18position'  : mem18position,
        'mem18title'     : mem18title,
        'mem19classname' : mem19classname,
        'mem19position'  : mem19position,
        'mem19title'     : mem19title,
        'mem20classname' : mem20classname,
        'mem20position'  : mem20position,
        'mem20title'     : mem20title,
        'mem21classname' : mem21classname,
        'mem21position'  : mem21position,
        'mem21title'     : mem21title,
        'mem22classname' : mem22classname,
        'mem22position'  : mem22position,
        'mem22title'     : mem22title,
        'mem23classname' : mem23classname,
        'mem23position'  : mem23position,
        'mem23title'     : mem23title,
        'mem24classname' : mem24classname,
        'mem24position'  : mem24position,
        'mem24title'     : mem24title,
        'mem25classname' : mem25classname,
        'mem25position'  : mem25position,
        'mem25title'     : mem25title,
        'mem26classname' : mem26classname,
        'mem26position'  : mem26position,
        'mem26title'     : mem26title,
        'mem27classname' : mem27classname,
        'mem27position'  : mem27position,
        'mem27title'     : mem27title,
        'mem28classname' : mem28classname,
        'mem28position'  : mem28position,
        'mem28title'     : mem28title,
        'mem29classname' : mem29classname,
        'mem29position'  : mem29position,
        'mem29title'     : mem29title,
        'mem30classname' : mem30classname,
        'mem30position'  : mem30position,
        'mem30title'     : mem30title,
        'mem31classname' : mem31classname,
        'mem31position'  : mem31position,
        'mem31title'     : mem31title,
        'mem32classname' : mem32classname,
        'mem32position'  : mem32position,
        'mem32title'     : mem32title,
        'mem33classname' : mem33classname,
        'mem33position'  : mem33position,
        'mem33title'     : mem33title,
        'mem34classname' : mem34classname,
        'mem34position'  : mem34position,
        'mem34title'     : mem34title,
        'mem35classname' : mem35classname,
        'mem35position'  : mem35position,
        'mem35title'     : mem35title,
        'mem36classname' : mem36classname,
        'mem36position'  : mem36position,
        'mem36title'     : mem36title,
        'mem37classname' : mem37classname,
        'mem37position'  : mem37position,
        'mem37title'     : mem37title,
        'mem38classname' : mem38classname,
        'mem38position'  : mem38position,
        'mem38title'     : mem38title,
        'mem39classname' : mem39classname,
        'mem39position'  : mem39position,
        'mem39title'     : mem39title,
        'mem40classname' : mem40classname,
        'mem40position'  : mem40position,
        'mem40title'     : mem40title,
        'mem41classname' : mem41classname,
        'mem41position'  : mem41position,
        'mem41title'     : mem41title,
        'mem42classname' : mem42classname,
        'mem42position'  : mem42position,
        'mem42title'     : mem42title,
        'mem43classname' : mem43classname,
        'mem43position'  : mem43position,
        'mem43title'     : mem43title,
        'mem44classname' : mem44classname,
        'mem44position'  : mem44position,
        'mem44title'     : mem44title,
        'mem45classname' : mem45classname,
        'mem45position'  : mem45position,
        'mem45title'     : mem45title,
        'mem46classname' : mem46classname,
        'mem46position'  : mem46position,
        'mem46title'     : mem46title,
        'mem47classname' : mem47classname,
        'mem47position'  : mem47position,
        'mem47title'     : mem47title,
        'mem48classname' : mem48classname,
        'mem48position'  : mem48position,
        'mem48title'     : mem48title,
        'mem49classname' : mem49classname,
        'mem49position'  : mem49position,
        'mem49title'     : mem49title,
        'mem50classname' : mem50classname,
        'mem50position'  : mem50position,
        'mem50title'     : mem50title,
        'mem51classname' : mem51classname,
        'mem51position'  : mem51position,
        'mem51title'     : mem51title,
        'mem52classname' : mem52classname,
        'mem52position'  : mem52position,
        'mem52title'     : mem52title,
        'mem53classname' : mem53classname,
        'mem53position'  : mem53position,
        'mem53title'     : mem53title,
        'mem54classname' : mem54classname,
        'mem54position'  : mem54position,
        'mem54title'     : mem54title,
        'mem55classname' : mem55classname,
        'mem55position'  : mem55position,
        'mem55title'     : mem55title,
        'mem56classname' : mem56classname,
        'mem56position'  : mem56position,
        'mem56title'     : mem56title,
        'mem57classname' : mem57classname,
        'mem57position'  : mem57position,
        'mem57title'     : mem57title,
        'mem58classname' : mem58classname,
        'mem58position'  : mem58position,
        'mem58title'     : mem58title,
        'mem59classname' : mem59classname,
        'mem59position'  : mem59position,
        'mem59title'     : mem59title,
        'mem60classname' : mem60classname,
        'mem60position'  : mem60position,
        'mem60title'     : mem60title,
        'mem61classname' : mem61classname,
        'mem61position'  : mem61position,
        'mem61title'     : mem61title,
        'mem62classname' : mem62classname,
        'mem62position'  : mem62position,
        'mem62title'     : mem62title,
        'mem63classname' : mem63classname,
        'mem63position'  : mem63position,
        'mem63title'     : mem63title,
        'mem64classname' : mem64classname,
        'mem64position'  : mem64position,
        'mem64title'     : mem64title,
        'mem65classname' : mem65classname,
        'mem65position'  : mem65position,
        'mem65title'     : mem65title,
        'mem66classname' : mem66classname,
        'mem66position'  : mem66position,
        'mem66title'     : mem66title,
        'mem67classname' : mem67classname,
        'mem67position'  : mem67position,
        'mem67title'     : mem67title,
        'mem68classname' : mem68classname,
        'mem68position'  : mem68position,
        'mem68title'     : mem68title,
        'mem69classname' : mem69classname,
        'mem69position'  : mem69position,
        'mem69title'     : mem69title,
        'mem70classname' : mem70classname,
        'mem70position'  : mem70position,
        'mem70title'     : mem70title,
        'mem71classname' : mem71classname,
        'mem71position'  : mem71position,
        'mem71title'     : mem71title,
        'mem72classname' : mem72classname,
        'mem72position'  : mem72position,
        'mem72title'     : mem72title,
        'mem73classname' : mem73classname,
        'mem73position'  : mem73position,
        'mem73title'     : mem73title,
        'mem74classname' : mem74classname,
        'mem74position'  : mem74position,
        'mem74title'     : mem74title,
        'mem75classname' : mem75classname,
        'mem75position'  : mem75position,
        'mem75title'     : mem75title,
        'mem76classname' : mem76classname,
        'mem76position'  : mem76position,
        'mem76title'     : mem76title,
        'mem77classname' : mem77classname,
        'mem77position'  : mem77position,
        'mem77title'     : mem77title,
        'mem78classname' : mem78classname,
        'mem78position'  : mem78position,
        'mem78title'     : mem78title,
        'mem79classname' : mem79classname,
        'mem79position'  : mem79position,
        'mem79title'     : mem79title,
        'mem80classname' : mem80classname,
        'mem80position'  : mem80position,
        'mem80title'     : mem80title
    } 
    return render_template('index.html', **templateData, async_mode=socketio.async_mode)
    
@app.route("/favicon.ico")
def favicon():
    return ('favicon.ico')    

@app.route("/servicepage.html")
def service():
    return render_template('servicepage.html')
   
@app.route("/<deviceName>/<myDuty>")
def action(deviceName, myDuty):
    global posAZ
    global dirAZ
    global posEL
    global dirEL
    global config
    global Skew
    global SrvMin
    global SrvMax
    global Polar
    global SrvStep
    # AZ east start
    if ((deviceName == 'AZE') and (myDuty == '1')):
        StartMoveEast()
    # AZ east stop
    elif ((deviceName == 'AZE') and (myDuty == '0')):
        StopMoveEast()
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Azimut = {posAZ} ; Origin AZ = {int(pi1.read(InputOAz))} ; Origin EL = {int(pi1.read(InputOEl))} .")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})    
    # AZ west start
    elif ((deviceName == 'AZW') and (myDuty == '1')):
        StartMoveWest()
    # AZ west stop
    elif ((deviceName == 'AZW') and (myDuty == '0')):
        StopMoveWest()
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Azimut = {posAZ} ; Origin AZ = {int(pi1.read(InputOAz))} ; Origin EL = {int(pi1.read(InputOEl))} .")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})     
    # EL up start
    elif ((deviceName == 'ELU') and (myDuty == '1')):
        StartMoveUp()
    # EL up stop
    elif ((deviceName == 'ELU') and (myDuty == '0')):
        StopMoveUp()
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Elevace = {posEL} ; Origin AZ = {int(pi1.read(InputOAz))} ; Origin EL = {int(pi1.read(InputOEl))} .")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
    # EL down start             
    elif ((deviceName == 'ELD') and (myDuty == '1')):
        StartMoveDown()
    # EL down stop    
    elif ((deviceName == 'ELD') and (myDuty == '0')):
        StopMoveDown()
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Elevace = {posEL} ; Origin AZ = {int(pi1.read(InputOAz))} ; Origin EL = {int(pi1.read(InputOEl))} .")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})    
    # Servo1 step left
    elif ((deviceName == 'SKEWL') and (myDuty == '1')):
        if Skew > (SrvMin + round(45*(SrvMax-SrvMin)/180)):
            Skew-= round(SrvStep*(SrvMax-SrvMin)/180)
        if Polar == 'H':
            pi1.set_servo_pulsewidth(PortSr_1, Skew - round(45*(SrvMax-SrvMin)/180))
        elif Polar == 'V':
            pi1.set_servo_pulsewidth(PortSr_1, Skew + round(45*(SrvMax-SrvMin)/180))
    # Servo1 off
    elif ((deviceName == 'SKEWL') and (myDuty == '0')):
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Skew = {round((180*Skew-270000)/(SrvMax-SrvMin),1)}°.")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
    # Servo1 step right
    elif ((deviceName == 'SKEWR') and (myDuty == '1')):
        if Skew < (SrvMax - round(45*(SrvMax-SrvMin)/180)):
            Skew+= round(SrvStep*(SrvMax-SrvMin)/180)
        if Polar == 'H':
            pi1.set_servo_pulsewidth(PortSr_1, Skew - round(45*(SrvMax-SrvMin)/180))
        elif Polar == 'V':
            pi1.set_servo_pulsewidth(PortSr_1, Skew + round(45*(SrvMax-SrvMin)/180))
    # Servo1 off
    elif ((deviceName == 'SKEWR') and (myDuty == '0')):
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print(f"Skew = {round((180*Skew-270000)/(SrvMax-SrvMin),1)}°.")
        socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
    # Set Polarization H on
    elif ((deviceName == 'POLH') and (myDuty == '1')):
        Polar = 'H'
        pi1.set_servo_pulsewidth(PortSr_1, Skew - round(45*(SrvMax-SrvMin)/180))
    # Set Polarization H off
    elif ((deviceName == 'POLH') and (myDuty == '0')):
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
    # Set Polarization V on
    elif ((deviceName == 'POLV') and (myDuty == '1')):
        Polar = 'V'
        pi1.set_servo_pulsewidth(PortSr_1, Skew + round(45*(SrvMax-SrvMin)/180))
    # Set Polarization V off
    elif ((deviceName == 'POLV') and (myDuty == '0')):
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'SatPos', SatPos)
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'polar', Polar)
        config.set('Default', 'SatName', SatName)
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
    # Aktivovaná předvolba
    elif (deviceName == 'MEM'):
        print(f"Aktivována předvolba číslo {myDuty} .")
        if ((config.getint('mem' + myDuty, 'posaz') != 0) and (config.getint('mem' + myDuty, 'posel') != 0)) :
            MoveToNewPos('mem' + myDuty)
            config.set('Default', 'PosAZ', str(posAZ)) 
            config.set('Default', 'PosEL', str(posEL))
            config.set('Default', 'SatPos', SatPos)
            config.set('Default', 'Skew', str(Skew))
            config.set('Default', 'polar', Polar)
            config.set('Default', 'SatName', SatName)
            with open('config.ini', 'w') as configfile:
                config.write(configfile)
            print(f"Aktuální hodnota azimutu je {posAZ} impulzů.")
            print(f"Aktuální hodnota elevace je {posEL} impulzů.")
            print(f"Hodnota aktuální pozice je {SatPos} .")
            print(f"Hodnota aktuálního skew je {round((180*Skew-270000)/(SrvMax-SrvMin),1)}° .")
            print(f"Název aktuálního satelitu je {SatName} .")
    return ('Content-type: text/html')

@app.route("/<memact>/<memid>/<memposition>/<memsatname>")
def memnewdata(memact, memid, memposition, memsatname):
    global SatPos
    global SatName
    global Skew
    global config
    if (memact == "memstore"):
        # Write data 
        print(f"Zapisuji nová data do předvolby {memid} .")
        SatPos = memposition
        SatName = memsatname
        config.set(memid, 'PosAZ', str(posAZ)) 
        config.set(memid, 'PosEL', str(posEL))
        config.set(memid, 'Skew', str(Skew))
        config.set(memid, 'SatPos', memposition)
        config.set(memid, 'SatName', memsatname)
        config.set('Default', 'PosAZ', str(posAZ)) 
        config.set('Default', 'PosEL', str(posEL))
        config.set('Default', 'Skew', str(Skew))
        config.set('Default', 'SatPos', memposition)
        config.set('Default', 'SatName', memsatname)
        with open('config.ini', 'w') as configfile:
            config.write(configfile) 
        print("Hotovo.")    
    elif (memact == "memclear"):
        # Clear data 
        print(f"Budu mazat předvolbu: {memid} .")
        config.set(memid, 'PosAZ', '0') 
        config.set(memid, 'PosEL', '0')
        config.set(memid, 'Skew', '1500')
        config.set(memid, 'SatPos', memid)
        config.set(memid, 'SatName', memid + ' - free')
        with open('config.ini', 'w') as configfile:
            config.write(configfile)
        print("Hotovo.")
    return ('Content-type: text/html')

@app.route("/<getpos>/")
def getposdevice(getpos):
    global posEL
    global posAZ
    global Skew
    global SrvMin
    global SrvMax    
    socketio.emit('set_data_3sel', 
            {'dataAZ': posAZ, 
             'dataEL': posEL, 
             'dataSkew': round((180*Skew-270000)/(SrvMax-SrvMin),1)})
    return ('Content-type: text/html')         
             
if __name__ == "__main__":
    try:
        app.run(host='0.0.0.0', port=8080, debug=True)
    finally:
        # your "destruction" code
        pi1.write(StartAz,0) 
        pi1.write(SetDirAz,0)
        pi1.write(StartEl,0)
        pi1.write(SetDirEl,0)
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        pi1.set_servo_pulsewidth(PortSr_1, 0)
        cbELA.cancel()
        cbELB.cancel()
        cbAZA.cancel()
        cbAZB.cancel()
